// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage;

/**
 * Store a centroid using lat/lon in double.
 */
public class Centroid extends Object {
    
    protected double lon= 0f;
    protected double lat= 0f;
    
    /**
     * Create a Centroid with lat/lon in double
     */
    public Centroid(double lon, double lat){
	this.lon = lon;
	this.lat = lat;
    }
    
    /**
     * Get longitude coordinate
     */
    public double getLon(){
	return lon; 
    }
    
    /**
     * Get latitude coordinate
     */
    public double getLat(){
	return lat; 
    }
    
    /**
     * For debug purpose.
     */
    public String toString () {
	return "Centroid: lat/lon : (" + this.lat + ", " + this.lon + ")";
    }
}
