// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage;

/**
 * Classes implementing this interface will be able
 * to handle <code>DataStorage</code> events.
 *
 * At the moment, we do not have any other event
 * than the "update needed" event after a <code>DataStorage.refresh()</code>
 *
 * @param source The DataStorage source for the event. 
 * @see DataStorage
 */
public interface SelectionLayerListener {
    /**
     * Send an Event to the objetcs this implements DataStorageListener.
     */
    public void dataStorageEvent (DataStorage source);
}
