// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.expr;

import com.bbn.openmap.LayerHandler;
import com.bbn.openmap.MapBean;
import com.bbn.openmap.util.PropUtils;


import fr.unicaen.openmap.app.ThemaMap;
import fr.unicaen.openmap.dataStorage.DataStorage;
import fr.unicaen.openmap.dataStorage.DataStorageListener;
import fr.unicaen.openmap.dataStorage.DataObject;
import fr.unicaen.openmap.dataStorage.DataTable;
import fr.unicaen.openmap.dataStorage.gui.DataTableModel;
import fr.unicaen.openmap.dataStorage.gui.DataTableStoragePanel;
import fr.unicaen.openmap.dataStorage.OMDataLocation;

//import fr.unicaen.openmap.dataStorage.expr.gui.JoinDataStoragePanel;
import fr.unicaen.openmap.exception.UnavailableColumnNameException;
import fr.unicaen.openmap.util.Util;
import java.util.ArrayList;
import java.util.Properties;
import javax.swing.Box;
import javax.swing.JComponent;

/**
 * Join rows of two DataStorage according to an expression
 */
public class JoinDataStorage extends ExprDataStorage {

    public static final String joinDSPropertyString = "joinDS";
    private DataStorage _dataStorage2 = null;

    public JoinDataStorage(DataStorageListener dsl) {
	this(dsl, null);
    }

    public JoinDataStorage(DataStorageListener dsl, DataStorage dataStorage) {     
	super(dsl, dataStorage);
    }

    public DataStorage getDataStorage2() {
        return _dataStorage2;
    }

    public void setDataStorage2(DataStorage dataStorage) {
        _dataStorage2 = dataStorage;
    }
   
    protected DataTable dataTable = new DataTable();
  
    public DataObject getElementAt(int i) {
        return dataTable.getDataObjectAt(i);
    }
  
    public int getCount() {
        return dataTable.getRowCount();
    }

    /** This method asumes dtsp is a DataTableStoragePanel and resets its DataTableModel.
     * <p>Should be used in setProperties...
     */
    protected void resetDataTableStoragePanel(DataTableModel dataTableModel) {
	if (dtsp == null)
	    dtsp = new DataTableStoragePanel(dataTableModel);
	else{
	    ((DataTableStoragePanel)dtsp).setModel(dataTableModel);
        }
    }

    protected boolean setColumnNames() {
	return false;
    }

    public void initialize() {
    }

    @Override
    public JComponent getGUI() {
        if (gui == null) {
        }
        Box b = Box.createVerticalBox();
        b.add(gui);
        b.add(getDataStorage().getGUI());

        return b;
    }

    @Override
    public void setProperties(String prefix, Properties properties) {
        String prefOld = prefix;
//        prefix = PropUtils.getScopedPropertyPrefix(prefix) + addColumnDSPropertyString + ".";
//        String dsClassName = properties.getProperty(prefix + dataStorageClassPropertyString, "");
//        setAddedColumnName(properties.getProperty(prefix + addedColumnNamePropertyString, "new"));
//        if ("".equals(dsClassName)) {
//            return;
//        }
//        
//        setDataStorage(Util.loadDataStorage(dsClassName, prefix, properties, this));
//        super.setProperties(prefOld, properties);
        initialize();
    }

    @Override
    public Properties getProperties(String prefix, Properties properties) {
        properties = super.getProperties(prefix, properties);
        prefix = PropUtils.getScopedPropertyPrefix(prefix) + joinDSPropertyString + ".";
//        properties.put(prefix + addedColumnNamePropertyString, addedColumnName);
//
//        if (getDataStorage() != null) {
//            properties.put(prefix + dataStorageClassPropertyString, getDataStorage().getClass().getCanonicalName());
//            properties = getDataStorage().getProperties(prefix, properties);
//        }
        return properties;
    }
}
