// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors
 */
// </header>

package fr.unicaen.openmap.exception;

import com.bbn.openmap.I18n;
import com.bbn.openmap.Environment;

/**
 *
 * @author jchauvea
 */
public class UnavailableColumnNameException extends Exception{

    public final static int DS_COLUMN_MESS = 1;
    public final static int FUNCTION_MESS = 2;

    private int type;

    protected I18n i18n = Environment.getI18n();

    public UnavailableColumnNameException(int t){
        this.type = t;
    }

    @Override
    public String getMessage(){
	switch (type) {
	case DS_COLUMN_MESS:
	    return i18n.get(this, "ds_mess", "Column Name already exists. Please choose a new one."); 
	case FUNCTION_MESS:
	    return i18n.get(this, "function_mess", "The choosen name is reserved (function name). Please pick another one");
	}
	return "*Internal error*";
    }
}

