// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;

import java.awt.BorderLayout;
import java.util.Properties;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import fr.unicaen.openmap.gui.dnd.MovableBox;

public class ConfigurationBox extends MovableBox {

    public static String className = "fr.unicaen.openmap.gui.ConfigurationBox";
    private JPanel configPanel;
    private String baseName;

    public ConfigurationBox() {
        super(BoxLayout.Y_AXIS, "Config", "Config", ThemaMapPanel.transferHandler);
        type = BoxLayout.X_AXIS;
        setName(i18n.get(this, "configuration", "Configuration"));
        baseName = getName();
        setNameTab(i18n.get(this, "configuration", "Configuration"));
        configPanel = new JPanel(new BorderLayout());
        add(configPanel);
    }

    public JPanel getConfigPanel() {
        return configPanel;
    }

    public void findAndInit(Object someObj) {
        if (someObj instanceof DisplayMenu) {
            DisplayMenu menu = (DisplayMenu) someObj;
            setMenuItem(menu.getConfigurationMenuItem());
            return;
        }
//        if (someObj instanceof LayersPanel) {
//            ((LayersPanel) someObj).setLayerGUIPanel(configPanel);
//        }

    }

    public void updateNames(String s) {
        String newName = baseName + " > " + s;
        setName(newName);
        setNameTab(newName);
    }

    public void removeConfigurationGUI() {
        configPanel.removeAll();
    }
}
