// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;

import javax.swing.*;

import com.bbn.openmap.gui.*;
import com.bbn.openmap.gui.menu.*;
import fr.unicaen.openmap.Environment;


/**
 * This FileMenu reuses the standard menu with customisation.
 * @see com.bbn.openmap.gui.FileMenu
 */
public class FileMenu extends AbstractOpenMapMenu {

    private String defaultText = "File";
    private String saveMapProperties = "SaveMapProperties";
    private String loadMapProperties = "LoadMapProperties";
    private int defaultMnemonic = 'F';

    /**
     * Create and add menuitems(About, SaveProperties, SaveAsImage and
     * Exit)
     */
    public FileMenu() {

        super();
        try {
//       // setText(defaultText);
//        //System.out.println("def "+i18n.get(this, defaultText, defaultText));
            setText(i18n.get(this, defaultText, defaultText));
            setMnemonic(defaultMnemonic);
            add(new NewProjectMenuItem());
            //add(new JSeparator());
            AboutMenuItem ami = new AboutMenuItem();
            add(ami);
            ami.setText(i18n.get(FileMenu.class, "about", "about"));
            String saveMapString = i18n.get(this, saveMapProperties, saveMapProperties);
            String loadMapString = i18n.get(this, loadMapProperties, loadMapProperties);
            add(new JSeparator());
            add(new fr.unicaen.openmap.gui.menu.SavePropertiesMenuItem(saveMapString));
            add(new fr.unicaen.openmap.gui.menu.LoadPropertiesMenuItem(loadMapString));
            add(new JSeparator());
            if(Environment.isJWS())
                add(new fr.unicaen.openmap.gui.menu.SaveAsMenuJWS());
            else
                add(new fr.unicaen.openmap.gui.menu.SaveAsMenu());
            MapBeanPrinterMenuItem mbpmi = new MapBeanPrinterMenuItem();
            add(mbpmi);
            mbpmi.setText(i18n.get(FileMenu.class, "print", "print"));
            add(new JSeparator());
            QuitMenuItem qmi = new QuitMenuItem();
            qmi.setText(i18n.get(FileMenu.class, "quit", "Quit"));
            add(qmi);

        } catch (Exception e) {
            System.err.println("----------------------------------------------");
            e.printStackTrace();
        }
    }
}
