// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JToggleButton;

import com.bbn.openmap.Layer;
import com.bbn.openmap.LayerHandler;
import com.bbn.openmap.PropertyHandler;
import com.bbn.openmap.gui.OMToolComponent;
import com.bbn.openmap.util.ComponentFactory;
import com.bbn.openmap.util.Debug;

import fr.unicaen.openmap.util.Util;

public class GraticuleTool extends OMToolComponent{

	protected JToggleButton bGraticule;
	
	protected LayerHandler layerHandler;
	
	protected Layer layer = null;
	
    public  GraticuleTool() {
        super();
      
        setKey("Graticule");
        bGraticule = new JToggleButton(Util.loadIcon("grid.png"));
        bGraticule.setToolTipText(i18n.get(this, "graticuleadd", "Add a graticule layer"));
        add(bGraticule);
        useAsTool = true;
        bGraticule.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				if(bGraticule.isSelected()){
					Object o = ComponentFactory.create("com.bbn.openmap.layer.GraticuleLayer");
					layer = (Layer)o;
					layer.setName("Graticule layer");
					layerHandler.addLayer(layer);
					bGraticule.setToolTipText(i18n.get(GraticuleTool.this, "graticulerm", "Remove the graticule layer"));
				}else{
					layerHandler.removeLayer(layer);
					bGraticule.setToolTipText(i18n.get(GraticuleTool.this, "graticuleadd", "Add a graticule layer"));
				}
			}});
        
    }
    
    public Container getFace() {
        if (getUseAsTool()) {
            return bGraticule;
        } else {
            return null;
        }
    }
    
    public boolean getUseAsTool(){return true;}
    
    /**
     * Looks for LayerHandler.
     */
    public void findAndInit(Object someObj) {

        if (someObj instanceof LayerHandler) {
           layerHandler = (LayerHandler) someObj;
     	
        }
    }
}
