package fr.unicaen.openmap.gui;

import com.bbn.openmap.Layer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import java.awt.Color;
import java.awt.Component;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

public class LayerCellRenderer extends DefaultTreeCellRenderer {

    @Override
    public Component getTreeCellRendererComponent(JTree tree, Object value,
            boolean selected, boolean expanded, boolean leaf, int row,
            boolean hasFocus) {

        Object obj = ((DefaultMutableTreeNode) value).getUserObject();
        Component c = super.getTreeCellRendererComponent(tree, value,selected,expanded,leaf,row,hasFocus);
        JComponent component;
        if (obj instanceof Thematic) {
            component = new ThematicTreeNodeComponent((LayersTree) tree,
                    (Thematic) obj);
        } else {
            if (obj instanceof Layer) {
                if (tree instanceof AtlasLayersTree) {
                    component = new AtlasLayerTreeNodeComponent((AtlasLayersTree) tree,
                            (Layer) obj, (DefaultMutableTreeNode) value);
                } else {
                    component = new LayerTreeNodeComponent((LayersTree) tree,
                            (Layer) obj);
                }
            } else {
                component = new JPanel();
                component.add(new JLabel(value.toString()));
                component.setBackground(Color.WHITE);
                /*super.getTreeCellRendererComponent(tree,
                        value,
                        selected,
                        expanded,
                        leaf,
                        row,
                        hasFocus);*/
            }
        }
        if (selected) {
            component.setBackground(Color.LIGHT_GRAY);
        }
        component.updateUI();
        return component;
    }
}
