package fr.unicaen.openmap.gui;

import com.bbn.openmap.Environment;
import com.bbn.openmap.I18n;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.tree.DefaultMutableTreeNode;

import com.bbn.openmap.Layer;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.ThematicVisuManagement;
import javax.swing.JOptionPane;

public class LayerPopupMenu extends JPopupMenu implements ActionListener {

    protected JMenuItem up, down, visible, remove, rename;
    protected ThematicVisuManagement visuManager;
    protected LayersTree tree;
    protected Object currentNode;
    protected I18n i18n = Environment.getI18n();

    public LayerPopupMenu(LayersTree tree, boolean v) {
        super();
        this.tree = tree;
        init();
        visible.setSelected(v);
        /*
         * up = new JMenuItem("up"); down = new JMenuItem("down"); visible = new
         * JCheckBoxMenuItem("visible"); //add = new JMenu("add visualisation");
         * //visuManager = new ThematicVisuManagement(add); add(up); add(down);
         * //add(new JSeparator()); //add(add); //add(new JSeparator());
         * add(visible); up.addActionListener(this);
         * down.addActionListener(this); visible.setSelected(true);
         * visible.addActionListener(this);
         */

    }

    private void init() {
        up = new JMenuItem(
                i18n.get(LayerControlButtonPanel.class, "moveLayerUpOne", "up"));
        down = new JMenuItem(
                i18n.get(LayerControlButtonPanel.class, "moveLayerDownOne", "down"));
        visible = new JCheckBoxMenuItem("visible");
        rename = new JMenuItem(i18n.get(LayerControlButtonPanel.class, "rename", "rename"));
        remove = new JMenuItem(
                i18n.get(LayerControlButtonPanel.class, "confirmDelete", "remove"));
        add(up);
        add(down);
        add(visible);
        add(rename);
        add(remove);
        up.addActionListener(this);
        down.addActionListener(this);
        visible.addActionListener(this);
        remove.addActionListener(this);
        rename.addActionListener(this);
    }

    public void show(Component cp, int x, int y, DefaultMutableTreeNode node) {
        super.show(cp, x, y);
        currentNode = node.getUserObject();
        Layer layer= (Layer) currentNode;
        visible.removeActionListener(this);
        visible.setSelected(layer.isVisible());
        visible.addActionListener(this);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        Object source = e.getSource();
        Layer layer= (Layer) currentNode;
        if (source == visible) {
            layer.setVisible(visible.isSelected());
            return;
        }

        if (source == up) {
            tree.moveUpSelectedNode();
            return;
        }

        if (source == down) {
            tree.moveDownSelectedNode();
            return;
        }

        if (source == remove) {
            tree.removeSelectedLayer(layer);
            tree.removeLayerGUI(layer);
            return;
        }

        if (source == rename) {
            String name = JOptionPane.showInputDialog(this,
                    i18n.get(this,"newname","New name:"),
                    i18n.get(this,"layer","layer") +" "+ layer.getName(),
                    JOptionPane.QUESTION_MESSAGE);
            if (!name.equals("")) {
                layer.setName(name);
                tree.updateUI();
            }
            return;
        }


    }
}
