package fr.unicaen.openmap.gui;

import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.tree.DefaultMutableTreeNode;

import com.bbn.openmap.Layer;

import com.bbn.openmap.util.PropUtils;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import java.beans.PropertyChangeEvent;
import java.util.Properties;
import javax.swing.JTabbedPane;
import javax.swing.tree.TreePath;

public class LayersPanelTree extends com.bbn.openmap.gui.LayersPanel {

    protected LayersTree tree, treeNoDirectories;
    protected ThemaMapPanelsManager.themamap_mode mode;
    protected JComponent layerGUIPanel;
    public final static String ThematicSelectedCmd = "ThematicSelected";
    private boolean atlasBuilt = false;
    protected String atlasPath;
    protected ThemaMapPanel mapPanel;
    // protected int nLayers = 0;

    @Override
    public void createPanel(Layer[] inLayers) {
        
        //if (tree == null) {
        if(ThemaMapPanelsManager.MODE == ThemaMapPanelsManager.themamap_mode.CLASSIC){
            setLayout(new BorderLayout());
            //if (ThemaMapPanelsManager.MODE == ThemaMapPanelsManager.themamap_mode.CLASSIC) {
                createClassicPanel(inLayers);
           // }
            } else {
            if(tree == null){
                setLayout(new BorderLayout());
                createAtlasPanel();
            }

            }
        //tree.updateUI();
        //} //new added layer
       /* else {
            int nLayersTmp = tree.getNLayers();
            //add node to the tree only if a layer was added
            // if a layer was removed, nothing is done
            //
            int diff = inLayers.length - nLayersTmp;
            if (diff > 0 && ThemaMapPanelsManager.MODE == ThemaMapPanelsManager.themamap_mode.CLASSIC) {
                //bad code ...
                for (int i = diff - 1; i >= 0; i--) {
                    tree.addLayerNode(inLayers[i]);
                }
                tree.updateUI();
            }
        }*/

    }

    private void createClassicPanel(Layer[] inLayers) {
        removeAll();
        add(controls, BorderLayout.NORTH);
        if (tree != null) {
            remove(tree);
        }
        tree = new ClassicLayersTree(
                new DefaultMutableTreeNode("Layers"), inLayers, layerHandler, layerGUIPanel);
        tree.setRootVisible(false);
        tree.addPropertyChangeListener(LayerSelectedCmd, this);
        tree.addPropertyChangeListener(ThematicSelectedCmd, this);
        tree.addPropertyChangeListener(LayerDeselectedCmd, this);
        tree.addPropertyChangeListener(mapPanel);
        //panes = new LinkedList<LayerPane>();
        add(new JScrollPane(tree), BorderLayout.CENTER);
        updateUI();
    }

    private void createAtlasPanel() {
        //System.out.println("==========================+CREATE ATLAS PANEL");
        remove(controls);
        JTabbedPane tabbedPane = null;
        if (!atlasBuilt) {
            atlasBuilt = true;
            tree = new AtlasLayersTree(new DefaultMutableTreeNode("Maps"), atlasPath, layerHandler, layerGUIPanel);
            tree.setRootVisible(false);
            tree.addPropertyChangeListener(LayerSelectedCmd, this);

            treeNoDirectories = new NoDirectoriesAtlasLayersTree(
                    new DefaultMutableTreeNode("Maps"), atlasPath, layerHandler, layerGUIPanel);
            treeNoDirectories.setRootVisible(false);
            treeNoDirectories.addPropertyChangeListener(LayerSelectedCmd, this);
            treeNoDirectories.addPropertyChangeListener(LayerSelectedCmd, this);
            treeNoDirectories.addPropertyChangeListener(LayerDeselectedCmd, this);
            tree.addPropertyChangeListener(mapPanel);
            //treeNoDirectories = new NoDirectoriesAtlasLayersTree((DefaultTreeModel)(tree.getModel()), layerHandler,layerGUIPanel);
            tabbedPane = new JTabbedPane();
            ((AtlasLayersTree) tree).addSynchronizedTree((AtlasLayersTree) treeNoDirectories);
            ((AtlasLayersTree) treeNoDirectories).addSynchronizedTree((AtlasLayersTree) tree);
            //tree.setShowsRootHandles(true);
            } else {
            return;
        }
        tree.addPropertyChangeListener(ThematicSelectedCmd, this);
        //panes = new LinkedList<LayerPane>();
        add(tabbedPane, BorderLayout.CENTER);
        tabbedPane.addTab(i18n.get(this, "atlas", "Atlas"), new JScrollPane(treeNoDirectories));
        tabbedPane.addTab(i18n.get(this, "explorer", "Explorer"), new JScrollPane(tree));

        updateUI();

    }

    public void deleteLayers(Layer[] layers) {
        tree.removeLayers();
        layerGUIPanel.removeAll();
        layerGUIPanel.updateUI();

    }

    public void deleteLayer(Layer l){
        tree.removeLayer(l);
    }

    public void setLayerGUIPanel(JComponent comp) {
        layerGUIPanel = comp;
        if (tree != null) {
            tree.setLayerGUIComp(comp);
        }
    }
    public static String atlasPathPropertyString = "atlaspath";

    @Override
    public void setProperties(String prefix, Properties props) {
        super.setProperties(prefix, props);
        prefix = PropUtils.getScopedPropertyPrefix(prefix);
        atlasPath = props.getProperty(prefix + atlasPathPropertyString, "atlas");
    }

    /**
     * Change a layer's position.
     */
    @Override
    public void moveLayer(Layer layer, String command) {

        if (command == LayerDownCmd) {
            tree.moveDownSelectedNode();
            DefaultMutableTreeNode n = tree.getObjectNode(layer, tree.getRootNode());
            TreePath tp = new TreePath(n.getPath());
            //System.out.println(tp.toString());
            tree.setSelectionPath(tp);
            //tree.updateUI();
            return;
        }
        if (command == LayerUpCmd) {
            tree.moveUpSelectedNode();
            DefaultMutableTreeNode n = tree.getObjectNode(layer, tree.getRootNode());
            TreePath tp = new TreePath(n.getPath());
            //System.out.println(tp.toString());
            tree.setSelectionPath(tp);
            //tree.updateUI();
            return;
        }
    }

    @Override
    public void propertyChange(PropertyChangeEvent pce) {
        super.propertyChange(pce);
        String command = pce.getPropertyName();
        Object obj = pce.getNewValue();

        if (obj instanceof Thematic) {
            if (command == ThematicSelectedCmd) {
                firePropertyChange(command, null, ((Thematic) obj));
                return;
            }
            if (command == LayerUpCmd) {
                tree.moveUpSelectedNode();
                return;
            }
            if (command == LayerDownCmd) {
                tree.moveDownSelectedNode();
                return;
            }

        }
        if (obj instanceof Layer) {
            if (command == LayerRemoveCmd) {
                tree.removeSelectedNode();
                layerHandler.removeLayer((Layer)obj);
                return;
            }
        }
    }

    @Override
    public void findAndInit(Object someObj){
        super.findAndInit(someObj);
        if(someObj instanceof ThemaMapPanel){
            mapPanel = (ThemaMapPanel)someObj;
        }

    }
}
