// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;

import com.bbn.openmap.Layer;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

import com.bbn.openmap.gui.LayersPanel;
import com.bbn.openmap.gui.menu.MapHandlerMenuItem;

public class NewProjectMenuItem extends MapHandlerMenuItem {

    private ThemaMapPanelsManager manager;
    protected fr.unicaen.openmap.LayerHandler layerHandler;
    //   protected I18n i18n = Environment.getI18n();

    public NewProjectMenuItem(final boolean dialog) {
        super("");
        setText(i18n.get(this, "new", "New"));
        addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (!dialog || JOptionPane.showConfirmDialog(NewProjectMenuItem.this,
                        i18n.get(NewProjectMenuItem.this, "accept_message", "You will lose unsaved data - Accept?"),
                        i18n.get(NewProjectMenuItem.this, "accept_title", "New ThemaMap Project"), JOptionPane.YES_NO_OPTION) ==
                        JOptionPane.OK_OPTION) {
		    if (layerHandler.getLayers() != null) {
			for (Layer l : layerHandler.getLayers()) {
			    //manager.getLayersPanel().deleteLayer(l);
			    layerHandler.removeLayer(l);
			}
		    }
                    layerHandler.setLayers();
                    //layerHandler.setLayers();
//                    manager.getLayersPanel().deleteLayers(layerHandler.getLayers());
//                    layerHandler.removeAll();
                    manager.getLayersPanel().getControls().actionPerformed(new ActionEvent(new Object(), 0, LayersPanel.LayerAddCmd));
                }
            }
        });


    }

    public NewProjectMenuItem() {
        this(true);
    }

    @Override
    public void findAndInit(Object someObj) {
        super.findAndInit(someObj);
        if (someObj instanceof ThemaMapPanelsManager) {
            manager = (ThemaMapPanelsManager) someObj;
            return;
        }
        if (someObj instanceof fr.unicaen.openmap.LayerHandler) {
            layerHandler = (fr.unicaen.openmap.LayerHandler) someObj;
            return;
        }

    }
}
