/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui;

import com.bbn.openmap.Environment;
import com.bbn.openmap.I18n;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.ColorScale;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.ColorScaleListener;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author jchauvea
 */
public abstract class ColorScalePanel extends JPanel implements ActionListener, ChangeListener {

    public static I18n i18n = Environment.getI18n();
    /**
     * Default property name for color scale.
     */
    public static final String CUSTOM_PROPERTY_NAME = "custom";
    public static final String CRAYOLA8_PROPERTY_NAME = "crayola8";
    public static final String CRAYOLA10_PROPERTY_NAME = "crayola10";
    public static final String CRAYOLARED_PROPERTY_NAME = "crayolared";
    public static final String CRAYOLABLUE_PROPERTY_NAME = "crayolablue";
    public static final String PASTEL_PROPERTY_NAME = "pastel";
    public static final String WATER_PROPERTY_NAME = "water";
    public static final String SAND_PROPERTY_NAME = "sand";
    public static final String CAMOUFLAGE_PROPERTY_NAME = "camouflage";
    public static final String WARM_PROPERTY_NAME = "warm";
    public static final String DESERT1_PROPERTY_NAME = "desert1";
    public static final String DESERT2_PROPERTY_NAME = "desert2";
    public static final String FOREST_PROPERTY_NAME = "forest";
    public static final String COLD_PROPERTY_NAME = "cold";
    public static final String FRUIT_PROPERTY_NAME = "fruit";
    public static final String BLUE_GREEN_PROPERTY_NAME = "blueGreen";
    public static final String FLESH_PROPERTY_NAME = "flesh";
    public static final String MINERAL_PROPERTY_NAME = "mineral";
    public static final String TITLE_PROPERTY_NAME = "title";
    public static final String SHADED_PROPERTY_NAME = "shaded";
    public static final String COLOR_CHOOSER_PROPERTY_NAME = "colorChooser";
    public static final String COLOR_SCALE_PROPERTY_NAME = "colorScale";
    // Some predifined ColorScale.
    private static final ColorScale crayola8 = new ColorScale(ColorScalePanel2.crayola8InHex,
            i18n.get(ColorScalePanel2.class, "crayola8", "Crayola 8"));
    private static final ColorScale crayola10 = new ColorScale(ColorScalePanel2.crayola10InHex,
            i18n.get(ColorScalePanel2.class, "crayola10", "Crayola 10"));
    //	 "Crayola 10"); // Crayola 10 does not exists : it is a subjective subset of Crayola 16
    private static final ColorScale crayolaRed = new ColorScale(ColorScalePanel2.crayolaRedInHex,
            i18n.get(ColorScalePanel2.class, "crayola16redsubset", "<html>Crayola 16 <i>(Red Subset)</i></html>"));
    private static final ColorScale crayolaBlue = new ColorScale(ColorScalePanel2.crayolaBlueInHex,
            i18n.get(ColorScalePanel2.class, "crayola16bluesubset", "<html>Crayola 16 <i>(Blue Subset)</i></html>"));

    /*    private static final ColorScale pastelColorScale = new ColorScale
    ("dd8b7d6b  ddffe7ba  dda52a2a  dd98f5ff  dd7fff00  ddfff8dc  ddb8860b  dd6e8b3d  ddff1493",
    i18n.get(ColorScalePanel.class, ColorScalePanel.PASTEL_PROPERTY_NAME, ColorScalePanel. PASTEL_PROPERTY_NAME));
    //  dd00bfff  dddcdcdc  dd141414", ; // FF69B4 FAF0E6 8B1C62 7D26CD CD9B9B CDB5CD 00C5CD";*/
    private static final ColorScale waterColorScale = new ColorScale(ColorScalePanel2.waterColorScaleInHex,
            i18n.get(ColorScalePanel2.class, ColorScalePanel2.WATER_PROPERTY_NAME, ColorScalePanel2.WATER_PROPERTY_NAME));
    private static final ColorScale sandColorScale = new ColorScale(ColorScalePanel2.sandColorScaleInHex,
            i18n.get(ColorScalePanel2.class, ColorScalePanel2.SAND_PROPERTY_NAME, ColorScalePanel2.SAND_PROPERTY_NAME));
    private static final ColorScale pastelColorScale = new ColorScale(ColorScalePanel2.pastelColorScaleInHex,
            i18n.get(ColorScalePanel2.class, ColorScalePanel2.PASTEL_PROPERTY_NAME, ColorScalePanel2.PASTEL_PROPERTY_NAME));
    //Others colormap.
    private static final ColorScale camouflageColorScale = new ColorScale(ColorScalePanel2.camouflageColorScaleInHex,
            i18n.get(ColorScalePanel2.class, ColorScalePanel2.CAMOUFLAGE_PROPERTY_NAME, "camouflage"));
    private static final ColorScale warmColorScale = new ColorScale(ColorScalePanel2.warmColorScaleInHex, "<html>warm</html>");
    //i18n.get(ColorScalePanel.class, ColorScalePanel.WARM_PROPERTY_NAME, "<html>warm<i>(test)</i></html>"));
    private static final ColorScale desert1ColorScale = new ColorScale(ColorScalePanel2.desert1ColorScaleInHex, "<html>desert1</html>");
    // i18n.get(ColorScalePanel.class, ColorScalePanel.DESERT1_PROPERTY_NAME, "desert1"));
    private static final ColorScale desert2ColorScale = new ColorScale(ColorScalePanel2.desert2ColorScaleInHex, "<html>desert2</html>");
    // i18n.get(ColorScalePanel.class, ColorScalePanel.DESERT2_PROPERTY_NAME, "desert2"));
    private static final ColorScale forestColorScale = new ColorScale(ColorScalePanel2.forestColorScaleInHex,
            i18n.get(ColorScalePanel2.class, ColorScalePanel2.FOREST_PROPERTY_NAME, "forest"));
    private static final ColorScale coldColorScale = new ColorScale(ColorScalePanel2.coldColorScaleInHex, "<html>cold</html>");
    // i18n.get(ColorScalePanel.class, ColorScalePanel.COLD_PROPERTY_NAME, "cold"));
    private static final ColorScale fruitColorScale = new ColorScale(ColorScalePanel2.fruitColorScaleInHex, "<html>fruit</html>");
    // i18n.get(ColorScalePanel.class, ColorScalePanel.FRUIT_PROPERTY_NAME, "fruit"));
    private static final ColorScale blueGreenColorScale = new ColorScale(ColorScalePanel2.blueGreenColorScaleInHex, "<html>blue-green</html>");
    // i18n.get(ColorScalePanel.class, ColorScalePanel.BLUE_GREEN_PROPERTY_NAME, "blue-green"));
    private static final ColorScale fleshColorScale = new ColorScale(ColorScalePanel2.fleshColorScaleInHex, "<html>flesh</html>");
    // i18n.get(ColorScalePanel.class, ColorScalePanel.FLESH_PROPERTY_NAME, "flesh"));
    private static final ColorScale mineralColorScale = new ColorScale(ColorScalePanel2.mineralColorScaleInHex,
            i18n.get(ColorScalePanel2.class, ColorScalePanel2.MINERAL_PROPERTY_NAME, "mineral"));
    /**
     * Used to keep user change to the color scale in order to re-use or save it.
     */
    private ColorScale customColorScale = new ColorScale("ddffffff ddffffff ddffffff ddffffff ddffffff ddffffff ddffffff ddffffff ddffffff ddffffff",
            i18n.get(this, "custom", "<html><i>custom</i></html>"));
    private ColorScale colorScales[] = {
        customColorScale,
        crayolaRed,
        crayolaBlue,
        desert1ColorScale,
        desert2ColorScale,
        coldColorScale,
        fruitColorScale,
        blueGreenColorScale,
        fleshColorScale,
        mineralColorScale
    };
    /**
     * Default color scale in Hex.
     */
    public static final String crayola8InHex =
            "ddb00000 ddeb5300 ddffdc00 dd125e14 dd111171 dd53006f dd653425 dd000000";
    public static final String crayola10InHex =
            "ddb00000 ddeb3200 ddeb5300 ddff8400 ddffdc00 dd3e9300 dd125e14 dd004b45 dd111171 dd53006f";
    // Crayola 10 does not exists : it is a subjective subset of Crayola 16
    public static final String crayolaRedInHex = // Crayola 16 (red subset)
            "ddffdc00 ddffba00 ddff9540 ddff8400 ddeb5300 ddeb3200 ddd00000 ddb00000 dd8b0038 dd8b0052";
    public static final String crayolaBlueInHex = // Crayola 16 (blue subset)
            "ddffdc00 ddbaff00 dd3e9300 dd125e14 dd004b45 dd121298 dd111171 dd34006f dd270053 dd53006f";
    public static final String waterColorScaleInHex = "cddffe7ba  dd66cdaa  dde0eeee  ddffebcd  dd8b3e2f  ddff34b3  dd8b668b  ddffc1c1  dd6ca6cd  dd00ff7f";
    public static final String sandColorScaleInHex = "dd8b7d6b  ddffe7ba  dd008b8b  dd006400  ddee7600  ddeec900  ddfff68f  ddffa07a";
    public static final String pastelColorScaleInHex = "ddffb300 ddedd3c1 dd74c476 dd80a6ce ddffff4d ddf4c6de dda6dba0 ddbfd1e5";
    public static final String camouflageColorScaleInHex = "523A1C 967E4D 76945F CABA89 F0EBE2 1C4761 4981A5 90B8D3 413A2C 224A1E";
    public static final String warmColorScaleInHex = "FADB00 FFCF00 F4B618 EFA500 EA7825 E5562C DF001C CB312F B12925 972520";
    public static final String desert1ColorScaleInHex = "E3DCD3 C0B1A1 AA9886 967E69 795F48 563E29 AFBBA0 8D9D7A 5E7646 315B27";
    public static final String desert2ColorScaleInHex = "EEE6D6 E1D4BC D3C09C C5A87B B68F62 A3774E 6F4919 EEEC00 FCC300 F29400";
    public static final String forestColorScaleInHex = "94A653 6B8F24 48651C 2C4311 B39A12 8E7C14 665A10 4A420B 60410B 432D07	";
    public static final String coldColorScaleInHex = "E5E9F4 C8D6EC 799FCF 4380BD 0E5FA7 004988 91D4F2 00ADE1 0096D9 0080BA";
    public static final String fruitColorScaleInHex = "DC3628 A47E58 E2873F D4002E 8CB03A 1D7951 9E0C46 DBE9C8 621F62 FDE077";
    public static final String blueGreenColorScaleInHex = "E8ECCB B8C763 BDCB1E 3DA231 00883C 0095A8 4DC0E6 00A1D9 007DBA 1E3789";// "1E3789 007DBA 00A1D9 4DC0E6 0095A8 00883C 3DA231 BDCB1E B8C763 E8ECCB ";
    public static final String fleshColorScaleInHex = "F8E8D7 F3D9BE EECAA5 D4A87E B9937C 977663 7B6152 5B443B F2C8BE E5B6AC";
    public static final String mineralColorScaleInHex = "A12116 7A1114 7E6666 6C4A4D 544045 4F0B0A 889EA9 5D7784 3F5E65 173542";
    private final String predefinedColorMapText[] = {
        //	i18n.get(ColorScalePanel.class, CUSTOM_PROPERTY_NAME, CUSTOM_PROPERTY_NAME),
        customColorScale.toString(),
        i18n.get(ColorScalePanel2.class, CRAYOLA8_PROPERTY_NAME, CRAYOLA8_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, CRAYOLA10_PROPERTY_NAME, CRAYOLA10_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, CRAYOLARED_PROPERTY_NAME, CRAYOLARED_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, CRAYOLABLUE_PROPERTY_NAME, CRAYOLABLUE_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, PASTEL_PROPERTY_NAME, PASTEL_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, WATER_PROPERTY_NAME, WATER_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, SAND_PROPERTY_NAME, SAND_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, CAMOUFLAGE_PROPERTY_NAME, CAMOUFLAGE_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, WARM_PROPERTY_NAME, WARM_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, DESERT1_PROPERTY_NAME, DESERT1_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, DESERT2_PROPERTY_NAME, DESERT2_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, FOREST_PROPERTY_NAME, FOREST_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, COLD_PROPERTY_NAME, COLD_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, FRUIT_PROPERTY_NAME, FRUIT_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, BLUE_GREEN_PROPERTY_NAME, BLUE_GREEN_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, FLESH_PROPERTY_NAME, FLESH_PROPERTY_NAME),
        i18n.get(ColorScalePanel2.class, MINERAL_PROPERTY_NAME, MINERAL_PROPERTY_NAME)
    };
    /**
     * Customized color scale in hex.
     */
    private String customColorScaleInHex = "ddffffff ddffffff ddffffff ddffffff ddffffff ddffffff ddffffff ddffffff ddffffff ddffffff";
    private String predefinedColorMapInHex[] = {
        customColorScaleInHex,
        crayola8InHex,
        crayola10InHex,
        crayolaRedInHex,
        crayolaBlueInHex,
        pastelColorScaleInHex,
        waterColorScaleInHex,
        sandColorScaleInHex,
        camouflageColorScaleInHex,
        warmColorScaleInHex,
        desert1ColorScaleInHex,
        desert2ColorScaleInHex,
        forestColorScaleInHex,
        coldColorScaleInHex,
        fruitColorScaleInHex,
        blueGreenColorScaleInHex,
        fleshColorScaleInHex,
        mineralColorScaleInHex
    };
    private JLabel numberLabel;
    protected JComboBox predefinedColorMaps;
    protected JSpinner colorNumber;
    protected JCheckBox shadedCheckBox;
    protected JCheckBox checkReverseColorMap;
    protected boolean shaded = false;
    protected ArrayList<ColorScaleButton> colorButtons = new ArrayList<ColorScaleButton>();
    protected ColorScale colorScale;
    protected JComponent panOption, panColorScale;

    public ColorScalePanel(ColorScale cs) {
        this.colorScale = cs;
        //colorButtons = new ColorScaleButton[colorScale.getColorNumber()];
        /*createColorScalePanel();
        createOptionPanel();
        add(panOption);
        add(panColorScale);*/
    }

    public abstract void createColorScalePanel();

    public void createOptionPanel() {

        predefinedColorMaps = new JComboBox(predefinedColorMapText);
        ActionListener predefinedActionListener = new ActionListener() {
            // Predefined colormaps

            public void actionPerformed(ActionEvent ae) {
                int index = ((JComboBox) ae.getSource()).getSelectedIndex();
                if (index < 0) {
                    return;
                }
                colorScale.initFromColorScaleInHex(predefinedColorMapInHex[index]);
                shadedCheckBox.setSelected(shaded = false);
                refreshColor();
            }
        };

        predefinedColorMaps.addActionListener(predefinedActionListener);
        //colorButtons = new ColorScaleButton[colorScale.getColorNumber()];
        colorNumber = new JSpinner();
        /*colorNumber.addChangeListener(new ChangeListener() {

            public void stateChanged(ChangeEvent arg0) {
                int n = ((Integer) colorNumber.getValue()).intValue();
                colorScale.setColorNumber(n);
                refreshPanel();
                return;
            }
        });*/
        colorNumber.setValue(colorScale.getColorNumber());
        checkReverseColorMap = new JCheckBox(i18n.get(ColorScalePanel.class, "reverse", "reverse"));
        shadedCheckBox = new JCheckBox(i18n.get(ColorScalePanel.class, "shaded", "shaded"));
        shadedCheckBox.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                if (shadedCheckBox.isSelected()) {
                    shaded = true;
                    colorScale.doShade();
                } else {
                    colorScale.setColorNumber(((Integer) colorNumber.getValue()).intValue());
                    colorScale.copy(new ColorScale(predefinedColorMapInHex[predefinedColorMaps.getSelectedIndex()], ""));
                    shaded = false;
                }
                refreshPanel();
            }
        });
        checkReverseColorMap.addActionListener(new ActionListener () {
	        public void actionPerformed(ActionEvent e) {
		    ColorScale c = new ColorScale(predefinedColorMapInHex[predefinedColorMaps.getSelectedIndex()],"");
		    //colorScale.setColorNumber(((Integer) colorNumber.getValue()).intValue());
		    colorScale.setReverse(checkReverseColorMap.isSelected());
                    colorScale.setColorNumber(((Integer) colorNumber.getValue()).intValue());
                    if(checkReverseColorMap.isSelected())
                        colorScale.reverseCopy(c);
                    else
                       colorScale.copy(c);
		    shadedCheckBox.setSelected(false);
		    refreshPanel();
		}
	    });
        panOption = Box.createVerticalBox();
        JPanel pNumber = new JPanel();
        numberLabel = new JLabel(i18n.get(this, "class_number", "Class number"));
        pNumber.add(numberLabel);
        pNumber.add(colorNumber);
        panOption.add(pNumber);
        JPanel pColors = new JPanel();
        pColors.add(new JLabel(i18n.get(ColorScalePanel.class, "colors", "Colors")));
        pColors.add(predefinedColorMaps);
        panOption.add(pColors);
        JPanel panCB = new JPanel();
        panCB.add(shadedCheckBox);
        panCB.add(checkReverseColorMap);
        panOption.add(panCB);


    }

    public void refreshPanel() {
        panColorScale.removeAll();
        createColorScalePanel();
        updateUI();
    }

    public void updateColorScaleAt(int position, Color color) {
        colorScale.setColor(position, color);
    }

    /**
     * Just refresh color scale buttons.
     */
    public void refreshColor() {
        for (int i = 0; i < colorButtons.size(); i++) {
            colorButtons.get(i).setBackground(colorScale.getColor(i));
            //colorCombos[i].setBackground(colorScale.getColor(i));
        }
        fireColorScaleChanged();
    }

    public void actionPerformed(ActionEvent arg0) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void stateChanged(ChangeEvent arg0) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
    private ArrayList<ColorScaleListener> listenerList = new ArrayList<ColorScaleListener>();

    public void addColorScaleListener(ColorScaleListener l) {
        listenerList.add(l);
    }

    public void removeColorScaleListener(ColorScaleListener l) {
        listenerList.remove(l);
    }

    protected void fireColorScaleChanged() {
        for (int i = 0; i < listenerList.size(); i++) {
            listenerList.get(i).colorScaleChanged(this);
        }
    }

    public void setColorNumberModel(SpinnerNumberModel spm) {
        colorNumber.setModel(spm);
        int nb = spm.getNumber().intValue();
        colorScale.setColorNumber(nb);
        refreshPanel();
    }

    public void updateColorNumberModel(SpinnerNumberModel spm){
        colorNumber.setModel(spm);
        colorNumber.updateUI();
    }

    public JComponent getPanOption() {
        return panOption;
    }

    @Override
    public void setEnabled(boolean b){
        super.setEnabled(b);
        colorNumber.setEnabled(b);
        predefinedColorMaps.setEnabled(b);
        shadedCheckBox.setEnabled(b);
        checkReverseColorMap.setEnabled(b);
        for(JButton button : colorButtons)
            button.setEnabled(b);

    }

    public void setNumberLabel(String label){
        numberLabel.setText(label);
    }
}
