/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui;

import fr.unicaen.openmap.util.Util;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JToggleButton;

/**
 *
 * @author jchauvea
 */
public class HorizontalThematicConfPanel extends ThematicConfPanel {

    public HorizontalThematicConfPanel(String name) {
        super(name, BoxLayout.Y_AXIS);
        collapsiblePane.setCollapsed(false);
        collapseButton = new HorizontalJButton(name, Util.loadIcon("expand.png"));
        /*collapseButton.setPreferredSize(new Dimension(, H_HEIGHT));
        collapseButton.setMinimumSize(new Dimension(content.getWidth(), H_HEIGHT));
        collapseButton.setMaximumSize(new Dimension(content.getWidth(), H_HEIGHT));*/
        add(collapseButton, BorderLayout.NORTH);
        //listener
        collapseButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent arg0) {
                if (collapsiblePane.isCollapsed()) {
                    collapsiblePane.setCollapsed(false);
                } else {
                    collapsiblePane.setCollapsed(true);
                }
            }
        });
        expand();
    }

    @Override
    public void expand() {
        fireOpened();
    }

    @Override
    public void collapse() {
        fireClosed();
    }

    @Override
    public void paint(Graphics g) {
        super.paint(g);
        Graphics2D g2d = (Graphics2D) g;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);
        g2d.setColor(Color.GRAY);
        //g2d.setColor(new Color(0xDD, 0xDD, 0xDD, 0xFF));
        g2d.drawRoundRect(0, 0, getWidth() - 1, getHeight() - 1, 12, 12);
    }

    class HorizontalJButton extends JToggleButton {

        public HorizontalJButton(String name, ImageIcon icon) {
            super(name);
            setBorderPainted(false);
            setContentAreaFilled(false);
        }

        @Override
        public void paint(Graphics g) {
            setPreferredSize(new Dimension(getParent().getWidth(), H_HEIGHT));
            setMinimumSize(new Dimension(getParent().getWidth(), H_HEIGHT));
            setMaximumSize(new Dimension(getParent().getWidth(), H_HEIGHT));
            setBackground(getParent().getBackground());
            setBorder(null);
            super.paint(g);
            Graphics2D g2d = (Graphics2D) g;
            g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                    RenderingHints.VALUE_ANTIALIAS_ON);
            g2d.setColor(new Color(0xDD, 0xDD, 0xDD, 0xFF));
            g2d.fillRoundRect(0, 0, getWidth(), getHeight(), 12, 12);
            collapseButton.setText(name);
            super.paintComponent(g);
            Image image = Util.loadIcon("collapse.png").getImage();
            g.drawImage(image, 5, 5, this);
            g2d.dispose();

        }
    }
}
