// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import java.awt.event.*;
import java.awt.Color;
import com.bbn.openmap.omGraphics.*;
import com.bbn.openmap.MapBean;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend.*;
import java.awt.Cursor;

public class OMControlNWAngle extends OMControlAngle {
	
    public OMControlNWAngle(int x, int y, int radius, Color c, Color sc, MapBean mb) {
	super(x, y, radius, c, sc, mb);
    }

    protected void setXYs() {
	setXs(new int[] { 
	    x0,          
	    x0,
	    x0-radius, 
	    x0-radius,   
	    x0+2*radius,
	    x0+2*radius });
	setYs(new int[] { 
	    y0,
	    y0+2*radius,
	    y0+2*radius,
	    y0-radius,
	    y0-radius,
	    y0	});
    }
    
    public void doActionDragged(MouseEvent e) {
	if (! isInMapBeanBounds(e.getX(), e.getY()))
	    return;

	int dx = e.getX() - x0;
	int dy = e.getY() - y0;
	
	OMResizeableGraphic omrg = (OMResizeableGraphic)getAppObject();
	omrg.translate(dx, dy);
	omrg.extend(-dx, -dy);
	omrg.refreshInteractiveGraphics();
    }

    /** respond to the extension of a border */
    public void extend(int dw, int dh) {
	// translate(0,0);
    }

    @Override
    public int getCursor() {
        return Cursor.NW_RESIZE_CURSOR;
    }

}

