// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import java.awt.Color;
import java.awt.event.MouseEvent;
import com.bbn.openmap.proj.coords.LatLonPoint;
import com.bbn.openmap.omGraphics.OMPoint;


/**
 * Control Point which allow to the user to move an OMFlow - It is representing
 * by a yellow square image
 * @author jerome chauveau
 *
 */
public class OMFlowControlPoint extends OMPoint implements ThemaMapControlPoint/*OMScalingIcon*//* OMControlPoint */ {

    private OMFlow omFlow;

    public OMFlowControlPoint(/*int index,*/ int x, int y, OMFlow flow/*, float radius, OMAbstractFlow omflow,ImageIcon img*/) {
        super(x, y);
        setFillPaint(Color.YELLOW);
        setSelectPaint(Color.RED);
        this.omFlow = flow;

    }

    public OMFlowControlPoint(int index, LatLonPoint llpt, OMFlow flow) {
        super(llpt.getLatitude(), llpt.getLongitude());
        setFillPaint(Color.YELLOW);
        setSelectPaint(Color.RED);
        this.omFlow = flow;

    }

    public void doActionPressed(MouseEvent e) {
        if (e.getButton() == MouseEvent.BUTTON3) {
        } else {
            omFlow.startDrag();
        }
    }

    public void doActionReleased(MouseEvent e) {
        omFlow.endDrag();
    }

    public void doActionDragged(MouseEvent e) {
        omFlow.updatePosition(e.getX(), e.getY());
    }

    public void select() {
    }

    public void deselect() {
    }

    @Override
    public void setSelected(boolean bool) {
        setFillPaint(bool ? Color.RED : Color.YELLOW);
    }
}
