// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend;

import com.bbn.openmap.omGraphics.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.*;
import java.awt.Color;
import java.awt.Paint;

public class OMResizeableRect extends OMResizeableGraphic {
    private OMRect omRect;
    
    public OMResizeableRect(Refreshable refreshable, MouseControlPointsListener ml, int px1, int py1, int width, int height, Paint color) {
	this(refreshable, ml, px1, py1, width, height, color, Color.BLACK);
    }
    public OMResizeableRect(Refreshable refreshable, MouseControlPointsListener ml, int px1, int py1, int width, int height, Paint fillColor, Paint lineColor) {
	super(refreshable, ml, ""); // empty name as we don't want a GUI for it.
	omRect = new OMRect(px1, py1, px1+width, py1+height);
	omRect.setFillPaint(fillColor);
	omRect.setLinePaint(lineColor);
	
	addOMControlPoint(new OMControlNPoint(px1, py1+height/2, 
					      OMResizeableGraphic.OMControlPointRadius, 
					      Color.yellow, Color.red, refreshable.getMapBean()));
	add(omRect);
    }

    public void translate(int dx, int dy) {
        omRect.setLocation(omRect.getLeft()+dx, omRect.getTop()+dy, omRect.getRight()+dx, omRect.getBottom()+dy);
        for(int i = 0; i < omControlPoints.size(); i++)
            ((OMControlPoint)omControlPoints.getOMGraphicAt(i)).translate(dx, dy);
    }

    public void extend(int dw, int dh) {
//	omRect.setLocation(omRect.getLeft(), omRect.getTop(),
//			   omRect.getRight()+dw, omRect.getBottom()+dh);
    }

    public int getXAnchor() { return omRect.getLeft(); }
    public int getYAnchor() { return omRect.getTop(); }
    public int getWidth() { return omRect.getRight() - omRect.getLeft(); }
    public int getHeight() { return omRect.getBottom() - omRect.getTop(); }
    
}
