// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.util;
import java.util.*;
import java.util.regex.*;

import fr.unicaen.openmap.dataStorage.*;
import fr.unicaen.openmap.util.*;

/** Derived classes may be used as object functions to compute:
 * <ul>
 * <li> the value of a column (@see DataColumnValueComputer) </li>
 * <li> square root of a given column (@see DataSquareRootColumnValueComputer) </li>
 * <li> the sum of given columns (@see DataSumColumnsValueComputer), used in Pie and Histogram </li>
 * <li> square root of the sum of given columns (@see DataSquareRootSumColumnsValueComputer) </li>
 * </ul>
 * These objects are mainly used in @see Resizer.
 */
public class DataValueComputer {
    double getValue(DataObject data) { return 0; }
    double getValue(double v) { return v; }
    String getString(DataObject data) { return null; }
}
