// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu;

import fr.unicaen.openmap.event.RefreshableGUI;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;

import fr.unicaen.openmap.dataStorage.*;
import fr.unicaen.openmap.util.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
import com.bbn.openmap.event.*;
import com.bbn.openmap.omGraphics.*;
// import com.bbn.openmap.LatLonPoint;
import com.bbn.openmap.proj.coords.LatLonPoint;

/**
 * Dump centroid.
 */
public class DumpCentroid extends Disc {

    public DumpCentroid(ThematicDataDisplayLayer layer, String name) {
	this(layer, name, i18n.get(DumpCentroid.class, "dumpCentroid", "Dump Centroid"));
    }
    public DumpCentroid(ThematicDataDisplayLayer layer, String name, String typeName) { 
	super(layer, name, typeName); 
    }

    public void setProperties(String prefix, Properties properties) {
	super.setProperties(prefix, properties);
    }
    
    public Properties getProperties(String prefix, Properties properties) {
	properties = super.getProperties(prefix, properties);

	return properties;
    }
    
    public OMGraphicList generateGraphics(DataStorageIterator dsi) {
 
	//resizer.setMinMaxValue(dsi);
	OMSizeableGraphicList omgl = new OMSizeableGraphicList<OMDisc>();

	while (dsi.hasNext()) {
	    DataObject data = dsi.next();
	    OMDataLocation omdl = data.getOMDataLocation(geometryColumnName);
	    if (omdl == null)
		continue;

	    Centroid centroid = omdl.getCentroid();
	    if (centroid == null)
		continue;
	    
	    System.err.println(resizer.getString(data)+","+(float)centroid.getLat()+","+(float)centroid.getLon());
	}

	return omgl;
    }

    public JComponent getGUI(final DataStorageIterator dsi) {
	JComponent panel = super.getGUI(dsi);
	return panel;
    }
    

    public OMResizeableGraphic getLegend(Refreshable r, MouseControlPointsListener ml) {
	    return null;
    }

    public void refreshGUI(DataStorageIterator dsi) {
	super.refreshGUI(dsi);
    }
    
    class DumpCentroidMapMouseListener extends MapMouseAdapter {
	public boolean mousePressed(MapMouseEvent me) {
	    OMGraphicList list = getList();
	    if (list == null)
		return false;
	    OMGraphic omg = list.findClosest(me.getX(), me.getY(), 4);
	    if (omg == null)
		return false;
	    LatLonPoint llp = null; //me.getLatLon();
	    System.err.println(getDataColumnName());
	    Object o = omg.getAttribute(ThematicDataDisplayLayer.INDEX_IN_DS);
	    if (o == null)
		return false;
	    return false;
	    //   return dataStorageIterator.getDataStorage().getElementAtInHTML((Integer)o);
	}

    }

    MapMouseListener mapMouseListener = new DumpCentroidMapMouseListener();

    public MapMouseListener getMapMouseListener() { return mapMouseListener; }

}

