// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util.find;

import java.awt.Component;

import com.bbn.openmap.InformationDelegator;
import com.bbn.openmap.Layer;


//author : Yannick Lange, ylange@etu.info.unicaen.fr, DESS NAPI, juin-septembre 2003.
public class Search
{
    /**
     * Returns Overview's InformationDelegator from layer. 
     * To used to manage message from layer to user for example. @see setInfoLine() from FlowLayer
     * @param layer layer
     */
    public static InformationDelegator getInformationDelegator(Layer layer)
    {
	InformationDelegator informationDelegator = null;
	Component[] components = layer.getParent().getParent().getComponents(); //search components from Overview

	for (int i = 0; i<components.length; i++)
	    {
		//System.out.println("Component"+i+" : "+layers[i]);
		if (components[i] instanceof InformationDelegator) 
		    informationDelegator = (InformationDelegator)components[i];
	    }

	return informationDelegator;
    }
}
